<?php
/*
Plugin Name: Google Proxy Hack Defender
Plugin URI: http://seo.i-connector.com/google-proxy-hack/
Description: Security
Version: 0.1
Author: mosquito@reklamkereso.hu | Reverse-DNS-Forward code: bagiz
Author URI: http://www.reklamkereso.hu/
*/

// installation
function gphd_install() {
    add_option('gphd_active', 0);
}
		
if (isset ($_GET['activate']) && $_GET['activate'] == 'true') {
    add_action('init', 'gphd_install');
}
			


function gphd() {

    if (get_option('gphd_active')==0) return false;

// Get the user agent.
$ua = $_SERVER['HTTP_USER_AGENT'];

// Check the user agent to see if it's identifying itself as a search engine bot.
if(stristr($ua, 'msnbot') || stristr($ua, 'googlebot') || stristr($ua, 'yahoo slurp')){
    // The user agent is purporting to be MSN's bot or Google's bot or Yahoo! Slurp.
    // If the user agent string is spoofed, we won't find googlebot.com in the host name.

    // Get the IP address requesting the page.
    $ip = $_SERVER['REMOTE_ADDR'];
    // Reverse DNS lookup the IP address to get a hostname.
    $hostname = gethostbyaddr($ip);

    // Check for '.googlebot.com' and '/search.live.com' in hostname.
    if(!preg_match("/\.googlebot\.com$/", $hostname) &&!preg_match("/search\.live\.com$/", $hostname) &&!preg_match("/crawl\.yahoo\.net$/", $hostname)) {
        // The host name does not belong to either live.com or googlebot.com.
        // Remember the UA already said it is either MSNBot or Googlebot.
	$block = TRUE;
        header("HTTP/1.0 403 Forbidden");
        exit;
    } else {
        // Now we have a hit that half-passes the check. One last go:
        // Forward DNS lookup the hostname to get an IP address.
        $real_ip = gethostbyname($hostname);
	     if($ip!= $real_ip){
            $block = TRUE;
            header("HTTP/1.0 403 Forbidden");
            exit;
        } 
        else {
            // Real bot.
            $block = FALSE;
        }
    }
}
}

// Update admin options
function gphd_update() {

        if (isset ($_POST['save'])) {
	    update_option('gphd_active', $_POST['active']);
	    }
	}
						

// Admin options
function gphd_editor() {
	 gphd_update();

	echo '<style type="text/css">';
	echo '#gphdcenter { text-align:center; }';
	echo '</style>';

	echo '<div class="wrap">';

	echo '<div id="gphdcenter">';

	echo '<h2>Google Proxy Hack Defender Settings</h2>';

	echo '<form action="options-general.php?page=' . $_GET['page'] . '" method="post">';

	echo '<br />';
	echo "This plugin prevents third party removing your site from google SERPs";
	echo '<br />';
	echo '<br />';

	echo '<p>';	
	echo 'Google Proxy Hack Defender Active? ';
	echo '<select name="active">';
	echo '<option value="1"' . ((get_option('gphd_active') == 1)?' selected':'') .   ' />Yes';
	echo '<option value="0"' . ((get_option('gphd_active') == 0)?' selected':'') .   ' />No';
	echo '</select></p>';

	echo '<div style="clear:both;">';
	
	echo '<input type="hidden" name="save" value="yes" />';
	echo '<input type="submit" value="Save Settings" />';
	echo '</form>';
	
	echo '</div>';
	echo '</div>';
	echo '<br><br><br>';
}

function gphd_add_options_to_admin() {
	add_options_page('Proxy Hack Defender', 'Proxy Hack Defender', 8, __FILE__, 'gphd_editor');
}

if (function_exists('add_action')) {
	add_action('admin_menu', 'gphd_add_options_to_admin');
}


?>